
## cf http://dirk.eddelbuettel.com/blog/2010/09/07#straight_curly_or_compiled

## Xian's code, using <- for assignments and passing x down
f <- function(n, x=1) for (i in 1:n) x=1/(1+x)
g <- function(n, x=1) for (i in 1:n) x=(1/(1+x))
h <- function(n, x=1) for (i in 1:n) x=(1+x)^(-1)
j <- function(n, x=1) for (i in 1:n) x={1/{1+x}}
k <- function(n, x=1) for (i in 1:n) x=1/{1+x}

## now load some tools
library(rbenchmark)

## now run the benchmark
N <- 1e6
## benchmark(f(N,1), g(N,1), h(N,1), j(N,1), k(N,1),
##           columns=c("test", "replications",
##           "elapsed", "relative"),
##           order="relative", replications=10)


## now with Rcpp and C++
library(inline)

# and define our version in C++
src <- 'int n = as<int>(ns);
        double x = as<double>(xs);
        for (int i=0; i<n; i++) x=1/(1+x);
        return wrap(x); '
l <- cxxfunction(signature(ns="integer",
                           xs="numeric"),
                 body=src, plugin="Rcpp")

# now run the benchmark again
benchmark(f(N,1), g(N,1), h(N,1), j(N,1),
          k(N,1), l(N,1),
          columns=c("test", "replications",
          "elapsed", "relative"),
          order="relative", replications=10)
